dnl
dnl Some automake macros for use by libfbx (libtimer and libkbd)
dnl
dnl $Id: acinclude.m4,v 1.2 2001/01/06 17:13:10 lethal Exp $
dnl
dnl Test for LIBTIMER, and define LIBTIMER_CFLAGS and LIBTIMER_LIBS
dnl   to be used as follows:
dnl AM_PATH_LIBTIMER([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl
AC_DEFUN(AM_PATH_LIBTIMER,
[dnl 
dnl Get the cflags and libraries from the libtimer-config script
dnl
AC_ARG_WITH(LIBTIMER-prefix,[  --with-libtimer-prefix=PREFIX
                          Prefix where libtimer is installed (optional)],
            libtimer_config_prefix="$withval", libtimer_config_prefix="")
AC_ARG_WITH(libtimer-exec-prefix,[  --with-libtimer-exec-prefix=PREFIX
                          Exec prefix where libtimer is installed (optional)],
            libtimer_config_exec_prefix="$withval", libtimer_config_exec_prefix="")
AC_ARG_ENABLE(libtimertest, [  --disable-libtimertest     Do not try to compile and run a test libtimer program],
		    , enable_libtimertest=yes)

  if test x$libtimer_config_exec_prefix != x ; then
     libtimer_config_args="$libtimer_config_args --exec-prefix=$libtimer_config_exec_prefix"
     if test x${LIBTIMER_CONFIG+set} != xset ; then
        LIBTIMER_CONFIG=$libtimer_config_exec_prefix/bin/libtimer-config
     fi
  fi
  if test x$libtimer_config_prefix != x ; then
     libtimer_config_args="$libtimer_config_args --prefix=$libtimer_config_prefix"
     if test x${LIBTIMER_CONFIG+set} != xset ; then
        LIBTIMER_CONFIG=$libtimer_config_prefix/bin/libtimer-config
     fi
  fi

  AC_PATH_PROG(LIBTIMER_CONFIG, libtimer-config, no)
  min_libtimer_version=ifelse([$1], ,0.1.1,$1)

  AC_MSG_CHECKING(for libtimer - version >= $min_libtimer_version)
  no_libtimer=""
  if test "$LIBTIMER_CONFIG" = "no" ; then
    no_libtimer=yes
    AC_MSG_RESULT(no)
  else
    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS

    LIBTIMER_CFLAGS=`$LIBTIMER_CONFIG $libtimer_config_args --cflags`
    LIBTIMER_LIBS=`$LIBTIMER_CONFIG $libtimer_config_args --libs`
    libtimer_config_major_version=`$LIBTIMER_CONFIG $libtimer_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    libtimer_config_minor_version=`$LIBTIMER_CONFIG $libtimer_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    libtimer_config_micro_version=`$LIBTIMER_CONFIG $libtimer_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    AC_MSG_RESULT(yes)	
  fi
  AC_SUBST(LIBTIMER_CFLAGS)
  AC_SUBST(LIBTIMER_LIBS)
])

dnl Test for LIBKBD, and define LIBKBD_CFLAGS and LIBKBD_LIBS
dnl   to be used as follows:
dnl AM_PATH_LIBKBD([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl
AC_DEFUN(AM_PATH_LIBKBD,
[dnl 
dnl Get the cflags and libraries from the libkbd-config script
dnl
AC_ARG_WITH(LIBKBD-prefix,[  --with-libkbd-prefix=PREFIX
                          Prefix where libkbd is installed (optional)],
            libkbd_config_prefix="$withval", libkbd_config_prefix="")
AC_ARG_WITH(libkbd-exec-prefix,[  --with-libkbd-exec-prefix=PREFIX
                          Exec prefix where libkbd is installed (optional)],
            libkbd_config_exec_prefix="$withval", libkbd_config_exec_prefix="")
AC_ARG_ENABLE(libkbdtest, [  --disable-libkbdtest     Do not try to compile and run a test libkbd program],
		    , enable_libkbdtest=yes)

  if test x$libkbd_config_exec_prefix != x ; then
     libkbd_config_args="$libkbd_config_args --exec-prefix=$libkbd_config_exec_prefix"
     if test x${LIBKBD_CONFIG+set} != xset ; then
        LIBKBD_CONFIG=$libkbd_config_exec_prefix/bin/libkbd-config
     fi
  fi
  if test x$libkbd_config_prefix != x ; then
     libkbd_config_args="$libkbd_config_args --prefix=$libkbd_config_prefix"
     if test x${LIBKBD_CONFIG+set} != xset ; then
        LIBKBD_CONFIG=$libkbd_config_prefix/bin/libkbd-config
     fi
  fi

  AC_PATH_PROG(LIBKBD_CONFIG, libkbd-config, no)
  min_libkbd_version=ifelse([$1], ,0.1.1,$1)

  AC_MSG_CHECKING(for libkbd - version >= $min_libkbd_version)
  no_libkbd=""
  if test "$LIBKBD_CONFIG" = "no" ; then
    no_libkbd=yes
    AC_MSG_RESULT(no)
  else
    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS

    LIBKBD_CFLAGS=`$LIBKBD_CONFIG $libkbd_config_args --cflags`
    LIBKBD_LIBS=`$LIBKBD_CONFIG $libkbd_config_args --libs`
    libkbd_config_major_version=`$LIBKBD_CONFIG $libkbd_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    libkbd_config_minor_version=`$LIBKBD_CONFIG $libkbd_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    libkbd_config_micro_version=`$LIBKBD_CONFIG $libkbd_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    AC_MSG_RESULT(yes)
  fi
  AC_SUBST(LIBKBD_CFLAGS)
  AC_SUBST(LIBKBD_LIBS)
])

