/*
 *  libfbx-endian.c -- Endian Checker
 *  (C)opyright 2000-2001 U4X Labs
 *
 *  Written by: Paul Mundt     <lethal@u4xlabs.com>
 *              Sat Sep 30 05:05:51 EDT 2000
 *
 *  $Id: libfbx-endian.c,v 1.5 2001/01/31 22:13:15 lethal Exp $
 *
 *  	Determines if the machine we're running on is a little endian
 *  or a big endian system.
 *
 *  See ChangeLog for modifications, CREDITS for credits.
 *
 *  All source herein is copyright U4X Labs and its original author. 
 *  Any code modifications or additions are (C)opyright the original 
 *  author and U4X Labs respectively.
 *
 *  libfbx is free software; you can redistribute it and/or modify it 
 *  under the terms of the GNU Lesser General Public License as 
 *  published by the Free Software Foundation; either version 2.1 of 
 *  the License, or (at your option) any later version.
 *
 *  libfbx is distributed in the hope that it will be useful, but 
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with libfbx; if not, write to the Free Software 
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */
#include <libfbx/libfbx-arch.h>

/*
 * Function:    fb_determine_endianess()
 * Arguments:   None.
 * Returns:     0 for big, 1 for little
 * Description: Checks to see if we're on a little or a
 *              big endian system.
 */
inline int fb_determine_endianess()
{
	int x = 0x12345678;

	return (*(char *)&x == 0x78);
}

